function getElement(id) {
	if (_prefix == null || _prefix === "") {
		return $('#' + id);
	}
	else {
		return $('#' + _prefix + "-" + id);
	}
}

function getElementFor(container, id) {
	if (container == null) {
		return getElement(id);
	}
	else {
		if (_prefix == null || _prefix === "") {
			return $(container).find('#' + id);
		}
		else {
			return $(container).find(_prefix + "-" + id);
		}
	}
}

function updateOfferElementText(container, id, text) {
    var el = getElementFor(container, id);
    //window.alert(":: " + el);
    if (el != null) {
        el.html(text);
    }
}

function updateOfferElementImage(container, id, src) {
    var el = getElementFor(container, id);
    if (el != null) {
        el.attr("src", src);
    }
}


function showMore() {
    var a = window.MedioOfferActions;
    if (a !== undefined) {
        a.showMore();
    }
}

function initOfferDetails() {
    var minimizedHeight = 200;
    var animateTime = 200;
	var m = new Object();
	var offerAssign = window.MedioOfferFeed.getElementAsAssignments("m", 0);
	eval(offerAssign + "; ");
	var mo = [];
	var numOptions = m.getNumOptions;
	for (var i = 0; i < numOptions; i++) {
		mo[i] = new Object();
	}
	var optionsAssign = window.MedioOfferFeed.getElementOptionsAsAssignments("mo");
	eval(optionsAssign + "; ");

	initOfferDetailsFor(null, m, mo);

    var showMore = $(getElementFor(null, "medio-showMore"));
    var showLess = $(getElementFor(null, "medio-showLess"));

    showLess.hide();
    showMore.show();

      var description = $(getElementFor(null, "medio-offerDesc"));

      showMore.click(function () {
        var open_height = description.attr("box_h") + "px";
        description.stop().animate({"height":open_height}, animateTime);
        description.css("height", open_height);
        showLess.show();
        showMore.hide();
      });
      showLess.click(function () {
        description.stop().animate({"height":minimizedHeight}, animateTime);
        showLess.hide();
        showMore.show();
      });

      description.css("overflow", "hidden");
      description.attr("box_h", description.height());
      description.css("height", minimizedHeight)
}

function initOfferDetailsFor(container, o, mo) {
    if (o !== undefined) {

    	if ( (o.getLatLon == null || o.getLatLon == "") &&
    			(o.getCompleteAddress == null || o.getCompleteAddress == "") ) {
    		var mapDiv = getElementFor(container, "medio-mapDiv");
    		if (mapDiv != null && mapDiv != undefined) {
    			mapDiv.hide();
    		}
    		var locationDiv = getElementFor(container, "medio-locationDiv");
    		if (locationDiv != null && locationDiv != undefined) {
    			locationDiv.hide();
    		}
    		var redeemDiv = getElementFor(container, "medio-redeem");
    		if (redeemDiv != null && redeemDiv != undefined) {
    			redeemDiv.show();
    		}
    		updateOfferElementText(container, "medio-redeemMerchantName", o.getMerchantName);
    		var urlDiv = getElementFor(container, "medio-redeemMerchantUrl");
    		if (urlDiv != null && urlDiv != undefined) {
    			urlDiv.attr("href", o.getMerchantUri);
    		}
    		updateOfferElementText(container, "medio-redeemMerchantUrl", o.getMerchantUri);
    	}

    	var numOptions = o.getNumOptions;
    	if (mo != null && numOptions > 0) {
    		$("#PP-medio-optContainer").css("display", "block");
    		for (var i = 0; i < numOptions; i++) {
    			var opt = mo[i];
    			var optDiv = $("#PP-medio-optDiv").clone();
    			$(optDiv).attr("id", "PP-medio-optDiv-" + i);
        		$(optDiv).css("display", "block");
        		$("#PP-medio-optContainer").append(optDiv);
        		$(optDiv).find("#PP-medio-optTitle").html(opt.getTitle);
        		$(optDiv).find("#PP-medio-optPurchased").html(opt.getPrice);
        		$(optDiv).find("#PP-medio-optValue").html(opt.getValue);
        		$(optDiv).find("#PP-medio-optDiscPct").html(opt.getDiscountPercent);
        		var buyButton = $(optDiv).find("#buy-opt-button");
        		$(buyButton).html(opt.getPrice + " - Buy now");
        		$(buyButton).attr("value", "" + i);
        		$(buyButton).click(function() {
    			    	var ind = parseInt($(this).val());
    			    	window.MedioOfferActions.optionRequested(ind);
        		});
    		}
    		$("#buy-button").css("display", "none");
    	}

        updateOfferElementImage(container, "medio-organizationLogo", o.getMerchantIconURI);
        updateOfferElementText(container, "medio-offerTitle", o.getTitle);
        updateOfferElementText(container, "medio-offerMerchantName", o.getMerchantName);
        updateOfferElementText(container, "medio-offerDesc", o.getDescription);
        updateOfferElementText(container, "medio-termsText", o.getTermsText);
        updateOfferElementImage(container, "medio-offersImage", o.getOfferImageURI);
        updateOfferElementText(container, "medio-offerPrice", o.getPrice);
        updateOfferElementText(container, "medio-purchaseOfferPrice", o.getPrice);
        updateOfferElementText(container, "medio-offerValue", o.getValue);
        updateOfferElementText(container, "medio-offerDiscPct", o.getDiscountPercent);
        updateOfferElementText(container, "medio-offerPurchased", o.getNumberPurchased);
        updateOfferElementText(container, "medio-offerTimeRemaining", o.getTimeRemaining);
        updateOfferElementText(container, "medio-offerRedeemDate", o.getExpirationDate);
        updateOfferElementText(container, "medio-offerLocationName", o.getLocationName);
        updateOfferElementText(container, "medio-offerStreet", o.getLocationAddress);
        updateOfferElementText(container, "medio-offerCityStateZip", o.getCityStatePostalCode);
        updateOfferElementText(container, "medio-offerPhone", o.getMerchantPhone);
        updateOfferElementText(container, "medio-offerQuantity", "Quantity: " + o.getQuantity);
        updateOfferElementText(container, "medio-offerExpires", "Expires: " + o.getExpirationDate);
        var location = getElementFor(container, "medio-offersLocation");
        if (location != null) {
            var latLon = o.getLatLon;
            // Display map and address only if there is lat/lon data
            if (latLon != null) {
                $(location).css("display", "inline");
                updateOfferElementImage(container, 
                        "medio-offersMapThumbnail",
                        "http://maps.google.com/maps/api/staticmap?sensor=false&size=150x150&zoom=15&maptype=roadmap&markers=color:red|size:small|"
                                + latLon);
            }
        }
        var useRemainingBlock = getElementFor(container, "medio-use-remaining-block");
        if (useRemainingBlock != null) {
            var use = o.getRemainingUses;
			if (use != null) {
				updateOfferElementText(container, "medio-useRemaining", use + " remaining");
			}
        }
        updateOfferElementImage(container, "medio-offerBarcode", o.getBarcodeUrl);

        if (o.getRichCreativeURI === "") {
        	var medioPlayImage = getElementFor(container, "medio-playImage");
        	if (medioPlayImage.style != undefined) {
        		medioPlayImage.style.display = "none";
        	}
        }
        
        if (o.getId != null) {
        	var medioButton = getElementFor(container, "offerCloseButton");
        	if (medioButton != null) {
        		$(medioButton).click(function() { 
        			handleOfferMenuClick(container, o.getId);
    			});
        	}
        	var deleteCheckbox = getElementFor(container, "medio-deleteCheckbox");
        	if (deleteCheckbox != null) {
        		$(deleteCheckbox).change(function() {
        			window.jsOfferListener.onItemChecked(o.getId, $("#medio-deleteCheckbox:checked").val() !== undefined);
                    return true;
        		});
        	}
        	
        	var link = "offer://ShowOffer:" + o.getId;
        	var offerImageRef = getElementFor(container, "medio-offerImageRef");
        	if (offerImageRef != null) {
        		offerImageRef.attr("href", link);
        	}
        	var offerLinkRef = getElementFor(container, "medio-offerLinkRef");
        	if (offerLinkRef != null) {
        		offerLinkRef.attr("href", link);
        	}
        	var offerTitleRef = getElementFor(container, "medio-offerTitleRef");
        	if (offerTitleRef != null) {
        		offerTitleRef.attr("href", link);
        	}
        }
    }
}

function showMap() {
	var a = window.MedioOfferActions;
    if (a !== undefined) {
		a.showMap();
    }
}

function addToWallet(animateId, buttonId) {
    var a = window.MedioOfferActions;
    var el = document.getElementById(animateId);
    if ((el != null) && (a !== undefined)) {
        var x = el.offsetLeft;
        var y = el.offsetTop;
        var width = el.clientWidth;
        var height = el.clientHeight;
        a.addToWallet(buttonId, document.body.scrollTop, x, y, width, height);
    }
}

function showCreative() {
	// I cannot use documetion.location.href because it opens the link in new window
    var a = window.MedioOfferActions;
    if (a !== undefined) {
        a.showCreative();
    }
}

function useNow() {
    var a = window.MedioOfferActions;
    if (a !== undefined) {
        a.useNow();
    }
}

function callMerchant() {
}

